/***************************************************************************************

赤外線リモコンコード解析ソフト for Arduino

本ソースリストおよびソフトウェアは、ライセンスフリーです。
利用、編集、再配布等が自由に行えますが、著作権表示の改変は禁止します。

                                                 Copyright (c) 2009-2014 Wataru KUNINO
                                                 http://www.geocities.jp/bokunimowakaru/
***************************************************************************************/

#define DATA_LEN	16+2					// リモコンコードのデータ長(byte)+2
#define STRING_LEN	8						// 表示用の文字列最大値
#define BUTTON_PIN	19						// リモコン形式の変更用ボタン(Analog 5+14)
void button_init(){ pinMode(BUTTON_PIN, INPUT_PULLUP ); }
byte button(){ return(digitalRead(BUTTON_PIN)); }

// enum IR_TYPE{ AEHA=0, NEC=1, SIRC=2 };	// 家製協AEHA、NEC、SONY SIRC切り換え
#define AEHA        0
#define NEC         1
#define SIRC        2
byte type = AEHA;										// 赤外線方式

void setup() {
	Serial.begin(9600);	
	Serial.println("IR Tester by Wataru Kunino");
	button_init();
	ir_init();
	ir_read_init();
}

void loop(){
	byte i,len8;
	int len=0;											// 信号長
	byte data[DATA_LEN];
	char s[STRING_LEN];

	/* 赤外線リモコンコードの読み取り */
	Serial.print("Waiting for ");
	print_IrType(type);
	do{
		if( !button() ){
			type++;
			if(type>2) type=0;
			print_IrType(type);
			delay(100); while(!button()); delay(100);
		}
		len = ir_read(data, DATA_LEN, type);
		if(len==-2)Serial.println("SYNC ERROR");
	}while( len <= 0 );
	
	len8 = (byte)(len/8);
	if(len%8 != 0) len8++;
	
	/* 結果表示 */
	Serial.println("Recieved.");
	Serial.print("data[");
	Serial.print(len8,DEC);
	Serial.print("] = {");
	for(i=0; i<len8 ; i++){
		if(i>0) Serial.print(',');
		sprintf(s,"0x%02X",data[i]);
		Serial.print(s);
	}
	Serial.println("};");
	Serial.print("length  = ");
	Serial.println(len,DEC);
	
	/* テスト送信(バイト単位データのみ) */
	delay(1000);
	ir_send( data , len8 , type );
}

void print_IrType(const byte type){
	Serial.print("IR type = ");
	switch(type){
		case NEC:   Serial.println("NEC  "); break;
		case SIRC:  Serial.println("SIRC "); break;
		case AEHA:
		default:    Serial.println("AEHA "); break;
	}
}
